﻿//	ルビ分割修正
//						2007.05.25/14:30 修正	(C)CopyRight Mishima Print Co.
//						親字が１文字のルビはチェックしない
//						範囲指定を追加
//						2007.07.12/09:20 修正：親文字１字のチェックの有無を選択に

$.gc ();	//2007.05.25　ガーベッジコレクションを開始（不要なメモリを解放する）

zoom = app.activeWindow.zoomPercentage;

main();

function main(){
	if(app.documents.length == 0){
		errorMsg("ドキュメントが開かれていません。");
	}
	//	検索・置換機能を使用するので、それらを退避しておく
	var findPreferencesOld = app.findPreferences.properties;
	var changePreferencesOld = app.changePreferences.properties;
	app.findPreferences = NothingEnum.nothing;
	app.changePreferences = NothingEnum.nothing;

	//	テキスト部分が選択されていた場合、ストーリーも変換範囲に含める
	var RangeFlag = false;
	var AspredFlag = true;
	var selName = "";
	if(app.activeDocument.stories.length != 0){
		if(app.selection.length != 0){
			selName = app.selection[0].constructor.name;
			switch(selName){
				case "Cell":
				case "Table":
				case "InsertionPoint":
				case "Character":
				case "Word":
				case "TextStyleRange":
				case "Line":
				case "Paragraph":
				case "TextColumn":
				case "Text":
					AspredFlag = false;
				case "TextFrame":
					RangeFlag = true;
					break;
			}
		}
	}
	//	ダイアログを作成
	with(myDialog = app.dialogs.add({name:"ルビ分割修正スクリプト"})){
		with(dialogColumns.add()){
			with(dialogRows.add()){
				with(dialogColumns.add()){
					staticTexts.add({staticLabel:"範囲を指定:" });
				}
				with(dialogColumns.add()){
					var myRangeButtons = radiobuttonGroups.add();
					with(myRangeButtons){
						radiobuttonControls.add({staticLabel:"ドキュメント全体"});
						radiobuttonControls.add({staticLabel:"スプレッド", checkedState:true});
						if (RangeFlag){
							radiobuttonControls.add({staticLabel:"ストーリー"});
							radiobuttonControls.add({staticLabel:"テキストフレーム"});
							radiobuttonControls.add({staticLabel:"選択範囲"});
						}
					}
					var om1check = checkboxControls.add({staticLabel: "親文字１文字をチェックしない", checkedState:false});	//2007.07.12
				}
			}
		}
	}
//	ダイアログを表示
	if (myDialog.show()){
		var mySelection = app.selection[0];
		//	変換範囲の指定
		switch (myRangeButtons.selectedButton){
			case 0 :	//ドキュメント全体
				var range = app.activeDocument;
				break;
			case 1 :	//スプレッド
				if (!AspredFlag){
					if (selName == "Table" || selName == "Cell"){
						app.selection = app.selection[0].parent;
					} else {
						app.selection = app.selection[0].parentTextFrames[0];
					}
				}
				var rangeSpred = app.activeWindow.activeSpread;
				break;
			case 2 :	//ストーリー
				var range = app.selection[0].parentStory;
				break;
			case 3 :	//テキストフレーム
				if (app.selection[0].constructor.name == "TextFrame"){
					var pTextFreame = app.selection[0];
				} else {
					var pTextFreame = app.selection[0].parentTextFrames[0];
				}
				app.selection = pTextFreame.characters.itemByRange(0,-1);
				var range = app.selection[0];
				app.selection = NothingEnum.nothing;
				break;
			case 4 :	//選択範囲
				if (app.selection[0].constructor.name == "TextFrame"){
					app.selection = app.selection[0].characters.itemByRange(0,-1);
				}
				var range = app.selection[0];
				break;
		}
	//	検索
		var findList = new Array();
		switch (myRangeButtons.selectedButton){
			case 0 :	//ドキュメント全体を検索
				findListSet(range,findList);
				break;
			case 1 :	//スプレッドを検索
				for (var i = 0 ;i < rangeSpred.allPageItems.length;i++){
					var pObj = rangeSpred.allPageItems[i];
					if (pObj.constructor.name == "TextFrame"){
						if (pObj.characters.length > 0){
							app.selection = pObj.characters.itemByRange(0,-1);
							var rangef = app.selection[0];
							findListSet(rangef,findList);
						}
					}
					app.selection = NothingEnum.nothing;
				}
				break;
			case 2 :	//ストーリーを検索
				findListSet(range,findList);
				for (var i=0;i<range.textFrames.length;i++){
					for (var j=0;j<range.textFrames[i].allPageItems.length;j++){
						var pObj = range.textFrames[i].allPageItems[j];
						if (pObj.constructor.name == "TextFrame"){
							if (pObj.characters.length > 0){
								app.selection = pObj.characters.itemByRange(0,-1);
								var rangef = app.selection[0];
								findListSet(rangef,findList);
							}
						}
					}
					app.selection = NothingEnum.nothing;
				}
				break;
			case 3 :	//テキストフレームを検索
			case 4 :	//選択範囲
				findListSet(range,findList);
				for (var i = 0 ;i < range.allPageItems.length;i++){
					var pObj = range.allPageItems[i];
					if (pObj.constructor.name == "TextFrame"){
						if (pObj.characters.length > 0){
							app.selection = pObj.characters.itemByRange(0,-1);
							var rangef = app.selection[0];
							findListSet(rangef,findList);
						}
					}
					app.selection = NothingEnum.nothing;
				}
				break;
		}
	}
	var om1 = om1check.checkedState;
	myDialog.destroy();
	//findList.sort(sortindex);//並べ替えはルビを振られた箇所が多いと時間がかかるのでコメントアウト
	check(findList,om1);	//2007.07.12修正
//	退避しておいた検索・置換の設定を復帰
	app.findPreferences.properties = findPreferencesOld;
	app.changePreferences.properties = changePreferencesOld;
	if (app.findPreferences.kerningMethod=="None") app.findPreferences.kerningMethod = 1851876449;
	if (app.changePreferences.kerningMethod=="None") app.changePreferences.kerningMethod = 1851876449;
}

//	検索
function findListSet(range,findList){
	//モノルビをチェック
	app.findPreferences.rubyType = 1249013859;
	var findListMR = range.search();
	for (var i=0;i<findListMR.length;i++){
		findList.push(findListMR[i]);
	}
	//グループルビをチェック
	app.findPreferences.rubyType = 1249011570;
	var findListGR = range.search();
	for (var i=0;i<findListGR.length;i++){
		findList.push(findListGR[i]);
	}
}

function sortindex(a,b){
	return (a.index - b.index);
}

function check(findList,om1){	//2007.07.12 修正
	for (var i=0;i<findList.length;i++){
		if (!om1 || findList[i].characters.length > 1){	//2006.07.12 修正
			app.selection = findList[i];//-1];
			app.activeWindow.zoomPercentage = zoom;
			with (findList[i]){//-1]){
				var str = contents;
				var rubystr = rubyString;
				var id = index;
				var jisu = characters.length;
			}
			var rubyW = (rubystr.length + 3) * 15;
			var textW = (jisu + 1) * 15;
			with(myDialog = app.dialogs.add({name:"ルビ修正スクリプト"})){
				with(dialogColumns.add()){
					with(dialogRows.add()){
						with(dialogColumns.add()){	// ラベル類の列
							staticTexts.add({staticLabel:"ルビ:"});
							staticTexts.add({staticLabel:"親文字:"});
							staticTexts.add({staticLabel:"種類:"});
						}
						with(dialogColumns.add()){	// コントロール類の列
							RubyStrD = textEditboxes.add({editContents:rubystr,minWidth:rubyW});
							textD = textEditboxes.add({editContents:str,minWidth:textW});
							RubyTypeD = dropdowns.add({stringList: ["グループルビ","モノルビ"], selectedIndex:1});
						}
					}
				}
			}
			myReturn = myDialog.show();
			if (myReturn){
				var myStory = findList[i].parent;
				with(myStory.characters.itemByRange(id,id+jisu-1)){
					if (RubyTypeD.selectedIndex == 0)	rubyType = 1249011570;
					else 								rubyType = 1249013859;
					rubyString = RubyStrD.editContents;
				}
				if ((RubyTypeD.selectedIndex == 1)&&(jisu>1)){
					myStory.characters.itemByRange(id,id+jisu-1).rubyFlag = false;
					var rubytexts = RubyStrD.editContents.split("　");
					if (rubytexts.length==jisu){
						for (var j=0;j<jisu;j++){
							with(myStory.characters[id+j]){
								rubyString = rubytexts[j];
								rubyFlag = true;
							}
						}
					} else {
						myStory.characters.itemByRange(id,id+jisu-1).rubyFlag = true;
						alert("ルビの分割数がおかしいので再入力してください。");
						i -- ;//やり直し
					}
				}
			}
			myDialog.destroy();
		}//2006.11.29
	}
}

function errorMsg(str){
	alert(str);
	exit();
}